<?
// Here we define our client ID
define('AUTH_CLIENT_ID', '');

// Now our sand box auth key (if you wish to use this)
define('AUTH_KEY', '');

// And finally our live auth key
define('AUTH_KEY_LIVE', '');

// I have set this parameters in this array for the purpose of this demo, to make it clearer to see what is going on
$validate_address_action = array(
	'name' => 'SmartPayables, LLC',
	'address' => '8392 S Continental Divide Rd #105', 
	'address2' => '',
	'city' => 'Littleton', 
	'state' => 'CO',
	'zip' => '80127' 
);

// This function simply retrieves input from the _GET or _POST array with a possible default value if the key
// is not found in either array
function get_post($key, $default = '') {
	if (isset($_POST[$key])) {
		return $_POST[$key];
	} else if (isset($_GET[$key])) {
		return $_GET[$key];
	} else {
		return $default;
	}
}

// This function will perform communication with either sandbox OR live API platforms
function process_api($act, $params = array(), $test = false) {
	// Initialise curl
	if (!$test) {
		$ch = curl_init('http://api.smartpayables.com/' . $act);	
		$params['client_id'] = AUTH_CLIENT_ID;
		$params['akey'] = AUTH_KEY_LIVE;
	} else {
		$ch = curl_init('https://apisb.smartpayables.com/' . $act);
		$params['client_id'] = AUTH_CLIENT_ID;
		$params['akey'] = AUTH_KEY;
	}

  // Set post field and additional parameters
  curl_setopt($ch, CURLOPT_POST, true);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

  // Send request and save XML response to $s, free the curl instance
  $s = curl_exec($ch);  
  curl_close($ch);
    
  // Return XML response
  return $s;
}

// Let's call our simple function with payments/validate-address method and supply our parameters
// We will set test to false as we are demonstrating on the live platform
$xml_result = process_api('payments/validate-address', $validate_address_action, false);

// Let's output this response to show it
echo '<pre>' . htmlentities($xml_result) . '</pre>';
?>