<?
// This can be used via apisb.smartpayables.com or api.smartpayables.com (sandbox test environment, or live service)

// Here we define our client ID
define('AUTH_CLIENT_ID', '1');

// And finally our auth key
define('AUTH_KEY', '');

function upload_logo_file($filename) {
	$errors = array();
	
	$data = array(
		'client_id' => AUTH_CLIENT_ID, 
		'akey' => AUTH_KEY, 
		'method_id' => 2, 
		'logofile' => '@' . $filename,
		'name' => 'Logo Test Name',
		'is_default' => 0
	);

	// For sandbox
  $ch = curl_init('https://apisb.smartpayables.com/payments/upload_logo');

	// For live
  //$ch = curl_init('http://api.smartpayables.com/payments/upload_logo');
 
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $s = curl_exec($ch);
  curl_close($ch);

	return $s;
}

$payment_file_path = dirname(__FILE__) . '/logo-example.jpg';
$result = upload_logo_file($payment_file_path);

echo $result;
?>